// OpenSSL ǰŹ沽 TCP/IP ̿ץο (С¦)

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <openssl/ssl.h>
#include "integnet.h"

// ³Υݡ
#define PORT 12345

int main( void )
{
  // INET  STREAM ʥåȤκ
  int sb = socket( AF_INET, SOCK_STREAM, 0 );

  // ³ܰλ
  sockaddr_in addr = SOCKADDR_IN_INIT( AF_INET, htons(PORT), InAddr(htonl(INADDR_ANY)) );

  // ܰθ
  if( bind( sb, (sockaddr*)&addr, sizeof(addr) ) < 0 ){
    perror("bind");
    exit(1);
  }

  // ³׵μ(Ʊ1ޤ³ĤȤ)
  listen( sb, 1 );

  // ³׵μ
  int s = accept( sb, NULL, NULL );

  // SSLν
  SSL_library_init(); 
  SSL_CTX* ctx = SSL_CTX_new( SSLv2_server_method() ); 
  SSL* ssl = SSL_new( ctx );
  SSL_set_fd( ssl, s );

  // SSLθ̩ɤߤ
  SSL_use_certificate_file( ssl, "public.key", SSL_FILETYPE_PEM );
  SSL_use_PrivateKey_file( ssl, "private.key", SSL_FILETYPE_PEM );

  // SSL̿γ
  SSL_accept(ssl);

  char msg[64];
  int len;
  len = SSL_read( ssl, msg, sizeof(msg) );
  msg[len] = '\0';

  printf("Server received : %s\n", msg );
  
  // SSLνλ
  SSL_shutdown(ssl); 
  SSL_free(ssl); 
  SSL_CTX_free(ctx);

  // åȤѻ
  close(s);
  close(sb);

  return 0;
}
