#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "integnet.h"

int main( int, char* argv[] )
{
  hostent* hp;
  if( (hp = gethostbyname( argv[1] )) == NULL ){
    herror("gethostbyname");
    return 0;
  }

  printf("h_name         = %s\n", hp->h_name );
  printf("h_addrtype     = %d\n", hp->h_addrtype );
  printf("h_length       = %d\n", hp->h_length );

  int i;
  for( i=0; hp->h_aliases[i]; i++ ){
    printf("h_aliases[%d]   = %s\n", i, hp->h_aliases[i] );
  }
  for( i=0; hp->h_addr_list[i]; i++ ){
    in_addr sin_addr;
    bcopy( hp->h_addr_list[i], &sin_addr, hp->h_length );

    printf("h_addr_list[%d] = %s\n", i, inet_ntoa(sin_addr) );
  }
  return 0;
}
